Welcome to mirror list, hosted at ThFree Co, Russian Federation.

git.kernel.org/pub/scm/git/git.git - Unnamed repository; edit this file 'description' to name the repository.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJeff King <peff@peff.net>2007-12-16 10:21:04 +0300
committerJunio C Hamano <gitster@pobox.com>2007-12-16 23:52:40 +0300
commitd7e522cffb2224b91c9c0edde093fbb81a0289b0 (patch)
tree84d8e40fd754590b46c7592c37857fde24126ac2 /git-help--browse.sh
parent6ba78238a824282816944550edc4297dd2808a72 (diff)
rename git-browse--help to git-help--browse
The convention for helper scripts has been git-$TOOL--$HELPER. Since this is a "browse" helper for the "help" tool, git-help--browse is a more sensible name. Signed-off-by: Jeff King <peff@peff.net> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'git-help--browse.sh')
-rwxr-xr-xgit-help--browse.sh149
1 files changed, 149 insertions, 0 deletions
diff --git a/git-help--browse.sh b/git-help--browse.sh
new file mode 100755
index 0000000000..10b0a36a3d
--- /dev/null
+++ b/git-help--browse.sh
@@ -0,0 +1,149 @@
+#!/bin/sh
+#
+# This program launch a web browser on the html page
+# describing a git command.
+#
+# Copyright (c) 2007 Christian Couder
+# Copyright (c) 2006 Theodore Y. Ts'o
+#
+# This file is heavily stolen from git-mergetool.sh, by
+# Theodore Y. Ts'o (thanks) that is:
+#
+# Copyright (c) 2006 Theodore Y. Ts'o
+#
+# This file is licensed under the GPL v2, or a later version
+# at the discretion of Junio C Hamano or any other official
+# git maintainer.
+#
+
+USAGE='[--browser=browser|--tool=browser] [cmd to display] ...'
+
+# This must be capable of running outside of git directory, so
+# the vanilla git-sh-setup should not be used.
+NONGIT_OK=Yes
+. git-sh-setup
+
+# Install data.
+html_dir="@@HTMLDIR@@"
+
+test -f "$html_dir/git.html" || die "No documentation directory found."
+
+valid_tool() {
+ case "$1" in
+ firefox | iceweasel | konqueror | w3m | links | lynx | dillo)
+ ;; # happy
+ *)
+ return 1
+ ;;
+ esac
+}
+
+init_browser_path() {
+ browser_path=`git config browser.$1.path`
+ test -z "$browser_path" && browser_path=$1
+}
+
+while test $# != 0
+do
+ case "$1" in
+ -b|--browser*|-t|--tool*)
+ case "$#,$1" in
+ *,*=*)
+ browser=`expr "z$1" : 'z-[^=]*=\(.*\)'`
+ ;;
+ 1,*)
+ usage ;;
+ *)
+ browser="$2"
+ shift ;;
+ esac
+ ;;
+ --)
+ break
+ ;;
+ -*)
+ usage
+ ;;
+ *)
+ break
+ ;;
+ esac
+ shift
+done
+
+if test -z "$browser"
+then
+ for opt in "help.browser" "web.browser"
+ do
+ browser="`git config $opt`"
+ test -z "$browser" || break
+ done
+ if test -n "$browser" && ! valid_tool "$browser"; then
+ echo >&2 "git config option $opt set to unknown browser: $browser"
+ echo >&2 "Resetting to default..."
+ unset browser
+ fi
+fi
+
+if test -z "$browser" ; then
+ if test -n "$DISPLAY"; then
+ browser_candidates="firefox iceweasel konqueror w3m links lynx dillo"
+ if test "$KDE_FULL_SESSION" = "true"; then
+ browser_candidates="konqueror $browser_candidates"
+ fi
+ else
+ browser_candidates="w3m links lynx"
+ fi
+
+ for i in $browser_candidates; do
+ init_browser_path $i
+ if type "$browser_path" > /dev/null 2>&1; then
+ browser=$i
+ break
+ fi
+ done
+ test -z "$browser" && die "No known browser available."
+else
+ valid_tool "$browser" || die "Unknown browser '$browser'."
+
+ init_browser_path "$browser"
+
+ if ! type "$browser_path" > /dev/null 2>&1; then
+ die "The browser $browser is not available as '$browser_path'."
+ fi
+fi
+
+pages=$(for p in "$@"; do echo "$html_dir/$p.html" ; done)
+test -z "$pages" && pages="$html_dir/git.html"
+
+case "$browser" in
+ firefox|iceweasel)
+ # Check version because firefox < 2.0 does not support "-new-tab".
+ vers=$(expr "$($browser_path -version)" : '.* \([0-9][0-9]*\)\..*')
+ NEWTAB='-new-tab'
+ test "$vers" -lt 2 && NEWTAB=''
+ nohup "$browser_path" $NEWTAB $pages &
+ ;;
+ konqueror)
+ case "$(basename "$browser_path")" in
+ konqueror)
+ # It's simpler to use kfmclient to open a new tab in konqueror.
+ browser_path="$(echo "$browser_path" | sed -e 's/konqueror$/kfmclient/')"
+ type "$browser_path" > /dev/null 2>&1 || die "No '$browser_path' found."
+ eval "$browser_path" newTab $pages
+ ;;
+ kfmclient)
+ eval "$browser_path" newTab $pages
+ ;;
+ *)
+ nohup "$browser_path" $pages &
+ ;;
+ esac
+ ;;
+ w3m|links|lynx)
+ eval "$browser_path" $pages
+ ;;
+ dillo)
+ nohup "$browser_path" $pages &
+ ;;
+esac